﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.WebUI.WebDropDown;
using Infragistics.WebUI.Misc;
using Infragistics.Web.UI.NavigationControls;
using System.Data;
using Mworker.Fleet.classes.WebConfig;


namespace Mworker.Fleet.UserControl.Filter
{
   

    public partial class test : System.Web.UI.UserControl
    {
          
   
        #region properties

        public string _userBlclient;
        public string _userId;
        private string _userName;
        private string _userLanguage;
        public ETypeCheck TypeCheckAction = ETypeCheck.ShowMap;
        public ETypeRessource TypeRessource = ETypeRessource.MobileAsset;
        public String _CurrentUserID;
        private String _CurrentGroup;
        private String _IDCible;
        private bool _readOnly = false;

        #endregion

        #region Property
        public String GroupID
        {
            get { return _CurrentGroup; }
            set
            {
                _CurrentGroup = value;
                ViewState["CurrentGroup"] = value;
                DoRefresh();
            }
        }
        public String UserID
        {
            get { return _CurrentUserID; }
            set
            {
                _CurrentUserID = value;
                ViewState["CurrentUserID"] = value;
                DoRefresh();
            }
        }
        public bool ReadOnly
        {
            get { return _readOnly; }
            set
            {
                _readOnly = value;
                ViewState["ReadOnly"] = value;
                MainWebTreetest.Enabled = !_readOnly;
            }
        }
        public String IDCible
        {
            get { return _IDCible; }
            set
            {
                _IDCible = value;
                ViewState["IDCible"] = value;
                DoRefresh();
            }
        }

        public String Typecheckaction
        {
            get { return ""; } //TODO
            set
            {
                if (value == "ShowMap") { TypeCheckAction = ETypeCheck.ShowMap; }
                if (value == "Sms") { TypeCheckAction = ETypeCheck.Sms; }
                if (value == "UserAccount") { TypeCheckAction = ETypeCheck.UserAccount; }
                if (value == "GroupType") { TypeCheckAction = ETypeCheck.GroupType; }
                if (value == "Alertes") { TypeCheckAction = ETypeCheck.Alertes; }
  
            }

        }

        public String Typeressource
        {
            get 
            {
                if (TypeRessource == ETypeRessource.MobileAsset) { return "MobileAsset"; }
                if (TypeRessource == ETypeRessource.PassiveAsset) { return "PassiveAsset"; }
                if (TypeRessource == ETypeRessource.Zone) { return "Zone"; }
                return "";
            }  
            set
            {
                if (value == "MobileAsset") { TypeRessource = ETypeRessource.MobileAsset; }
                if (value == "PassiveAsset") { TypeRessource = ETypeRessource.PassiveAsset; }
                if (value == "Zone") { TypeRessource = ETypeRessource.Zone; }
            }
        }
        #endregion

        #region load

        protected void Page_Load(object sender, EventArgs e)
        {
            getCookieClient();
 //           TxtSearch.Attributes.Add("onkeyup", "return GetKeyPressTxtSearch(event,'" + Typeressource + "')");
//            btSearch.Attributes.Add("onclick", "LaunchTimer('" + Typeressource + "')");
            //ScriptManager.GetCurrent(this.Page).RegisterAsyncPostBackControl(this.LinkButton1);
                if (TypeRessource == ETypeRessource.MobileAsset)
                {
                    MainWebTreetest.ClientEvents.NodeClick = "testTreeNodeClickMobileAsset";
                    ContextMenutestTree.ClientEvents.ItemClick = "ContextMenutest_ItemClickMobileAsset";
                    ContextMenutestTree.Items.Clear();
                    ContextMenutestTree.Items.Add(Mworker.DataAccess.Helper.getText("BIZZDEV", _userName, "lbl_ShowOnMap", _userLanguage), "ZoomTo");
                    ContextMenutestTree.Items.Add(Mworker.DataAccess.Helper.getText("BIZZDEV", _userName, "TrajetTime", _userLanguage), "Trajet");
                }
                img_Expand.Attributes.Add("onclick", "return ExpandAlltest('" + Typeressource + "');");
                img_Collapse.Attributes.Add("onclick", "return CollapseAlltest('" + Typeressource + "');");
            if (string.IsNullOrEmpty(_CurrentUserID)) 
            {
                if (ViewState["CurrentUserID"] != null)
                {
                    _CurrentUserID = ViewState["CurrentUserID"].ToString();
                }
                else
                {
                    _CurrentUserID = _userId;
                }
            }
            if (string.IsNullOrEmpty(_CurrentGroup))
            {
                if (ViewState["CurrentGroup"] != null)
                {
                    _CurrentGroup = ViewState["CurrentGroup"].ToString();
                }
            }
            if (string.IsNullOrEmpty(_IDCible))
            {
                if (ViewState["IDCible"] != null)
                {
                    _IDCible = ViewState["IDCible"].ToString();
                }
            }
            if (ViewState["ReadOnly"] != null)
            {
                ReadOnly = (bool)ViewState["ReadOnly"];
            }
 

            this.TimerRessources.Enabled = true;

            if (!IsPostBack)
            {
                         Mworker.DataAccess.TypeRessources oType = new Mworker.DataAccess.TypeRessources(_userName, _userBlclient);
                        ddlType.DataSource = oType.getList(false, true);
                        ddlType.TextField = "Nom";
                        ddlType.DataKeyFields = "ID";
                        ddlType.ValueField = "ID";
                        ddlType.DataBind();

                      ddlType.Items.Add(new Infragistics.Web.UI.ListControls.DropDownItem(Mworker.DataAccess.Helper.getText("BIZZDEV", _userName, "All", _userLanguage), "0"));

                    ddlType.SelectedValue = "0";
                
                DoRefresh();
            }

        }

        private void getCookieClient()
        {

            if (Request.Cookies.AllKeys.Contains("ConnectedUserName"))
            {
                _userName = Request.Cookies["ConnectedUserName"].Value;
                _userId = Request.Cookies["ConnectedUserID"].Value;
                _userBlclient = Request.Cookies["ConnectedUserBLClient"].Value;
                _userLanguage = Request.Cookies["ConnectedUserLanguage"].Value;
            }
            else
            {
                Response.Redirect(Url.root + "Login.aspx");
            }

        }
        public void CreateNodesType(WebDataTree oTree)
        {
            
            DataTable dtTypes = new DataTable();
            List<ElementTypetest> TypesToBeAdded = new List<ElementTypetest>();
            if (TypeRessource == ETypeRessource.MobileAsset)
            {
                Mworker.DataAccess.TypeRessources Types = new Mworker.DataAccess.TypeRessources(_userId, _userBlclient);
                Types.UserID = null;
                dtTypes = Types.getList(false, false);
                for (int i = 0; i < dtTypes.Rows.Count; i++)
                {
                    TypesToBeAdded.Add(new ElementTypetest(dtTypes.Rows[i]["ID"].ToString(), dtTypes.Rows[i]["IDParent"].ToString(), dtTypes.Rows[i]["Description"].ToString()));
                }
            }
           
            
            int NbLoop=0;
            while ((TypesToBeAdded.Count > 0) && (NbLoop<50))
            {
                NbLoop++;
                ElementTypetest[] TabTypes = new ElementTypetest[TypesToBeAdded.Count];
                TypesToBeAdded.CopyTo(TabTypes);
                for (int i = 0; i < TabTypes.Count(); i++)
                {
                    if ((String.IsNullOrEmpty(TabTypes[i].IDParent)) || (TabTypes[i].IDParent == "0"))
                    {
                        DataTreeNode n = new DataTreeNode();
                        
                        n.Visible = (TypeCheckAction == ETypeCheck.GroupType);
                        if (TypeCheckAction == ETypeCheck.ShowMap)
                        {
                            if (Request.Url.ToString().Contains("?"))
                            {
                                //n.Text = "<HTML><A HREF=" + Request.Url + "&Type=" + TabTypes[i].id + " target=”_blank”>" + TabTypes[i].Description + "</A></HTML>";
                                n.Text = TabTypes[i].Description;
                                n.NavigateUrl = Request.Url + "&Type=" + TabTypes[i].id;
                                n.Target = "_blank";
                            }
                            else
                            {
                                //n.Text = "<HTML><A HREF=" + Request.Url + "?Type=" + TabTypes[i].id + " target=”_blank”>" + TabTypes[i].Description + "</A></HTML>";
                                n.Text = TabTypes[i].Description;
                                n.NavigateUrl = Request.Url + "?Type=" + TabTypes[i].id;
                                n.Target = "_blank";
                            }
                        }
                        else
                        {
                            n.Text = TabTypes[i].Description;
                        }
                        
                        n.Key = TabTypes[i].id;
                        oTree.Nodes.Add(n);
                        TypesToBeAdded.Remove(TabTypes[i]);
                    }
                    else
                    {
                        try
                        {
                            
                            Infragistics.Web.UI.NavigationControls.DataTreeNode node = FindNodeByKeyAllChilds(TabTypes[i].IDParent);
                            if (node != null)
                            {
                                DataTreeNode n = new DataTreeNode();
                                n.Visible = (TypeCheckAction == ETypeCheck.GroupType);
                                if (TypeCheckAction == ETypeCheck.ShowMap)
                                {
                                    if (Request.Url.ToString().Contains("?"))
                                    {
                                        n.Text = "<HTML><A HREF=" + Request.Url + "&Type=" + TabTypes[i].id + " target=”_blank”>" + TabTypes[i].Description + "</A></HTML>";
                                    }
                                    else
                                    {
                                        n.Text = "<HTML><A HREF=" + Request.Url + "?Type=" + TabTypes[i].id + " target=”_blank”>" + TabTypes[i].Description + "</A></HTML>";
                                    }
                                }
                                else
                                {
                                    n.Text = TabTypes[i].Description;
                                }

                                n.CheckState = Infragistics.Web.UI.CheckBoxState.Unchecked;
                                n.Key = TabTypes[i].id;
                                node.Nodes.Add(n);
                                TypesToBeAdded.Remove(TabTypes[i]);
                            }
                        }
                        catch (Exception exc)
                        {
                            System.Diagnostics.Debug.WriteLine(exc.Message);
                        }
                    }
                }
            }
        }

        public WebDataTree loadTreeViewRess(WebDataTree oTree, DataTable dt)
        {
            oTree.Nodes.Clear();
            CreateNodesType(oTree);
         
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                DataTreeNode child = new DataTreeNode();
                child.Key = dt.Rows[i]["ID"].ToString();

                try
                {
                    DataTreeNode ParentForThisChild = FindNodeByKeyAllChilds(dt.Rows[i]["Type"].ToString());
                    int w = 10+ParentForThisChild.Level * 20;
                    if ((TypeCheckAction == ETypeCheck.ShowMap) && (Convert.ToBoolean(dt.Rows[i]["ShowOnMap"])))
                    {
                        child.CheckState = Infragistics.Web.UI.CheckBoxState.Checked;
                    }
                   
                   
                        if ((dt.Rows[i]["CategoryName"].ToString() == "camioncontainer") || ((dt.Rows[i]["CategoryName"].ToString() == "tracteur")))
                        {
                            String RepAssociation = "SansAssociation";
                            if ((int.Parse(dt.Rows[i]["NbreTrailersInAssociation"].ToString()) >= 1) && (int.Parse(dt.Rows[i]["NbreOthersInAssociation"].ToString()) == 0)) { RepAssociation = "AvecRemorque"; }
                            if ((int.Parse(dt.Rows[i]["NbreTrailersInAssociation"].ToString()) == 0) && (int.Parse(dt.Rows[i]["NbreOthersInAssociation"].ToString()) >= 1)) { RepAssociation = "AssocieSansRemorque"; }
                            if ((int.Parse(dt.Rows[i]["NbreTrailersInAssociation"].ToString()) >= 1) && (int.Parse(dt.Rows[i]["NbreOthersInAssociation"].ToString()) >= 1)) { RepAssociation = "AssocieAvecRemorque"; }
                            child.ImageUrl = "~/Images/Ressources/List/" + dt.Rows[i]["color"].ToString() + "/" + dt.Rows[i]["CategoryName"].ToString() + "/" + RepAssociation + "/" + dt.Rows[i]["NomImage"].ToString() + dt.Rows[i]["Color"].ToString() + ".png";
                        }
                        else
                        {
                            child.ImageUrl = "~/Images/Ressources/List/" + dt.Rows[i]["color"].ToString() + "/" + dt.Rows[i]["CategoryName"].ToString() + "/" + dt.Rows[i]["NomImage"].ToString() + dt.Rows[i]["Color"].ToString() + ".png";
                        }
                    
                    if (String.IsNullOrEmpty(dt.Rows[i]["LastCom"].ToString()))
                    {
                        child.Text = "<B>" + dt.Rows[i]["DescriptionTreeView"].ToString() + "</B>";
                    }
                    else
                    {
                        child.Text = "<B>" + dt.Rows[i]["DescriptionTreeView"].ToString() + "</B> <span style=\"display:inline; font-size:7px;\"> (" + dt.Rows[i]["LastCom"].ToString()+") </SPAN>";
                    }
    
                    HideAllParents(ParentForThisChild,false);
                    ParentForThisChild.Nodes.Add(child);
                }
                catch (Exception exc)
                {
                    System.Diagnostics.Debug.WriteLine("ERROR : " + dt.Rows[i]["Type"].ToString()+"  "+exc.Message);
                }
           }

            MakeParentsTag();
       
            return oTree;
        }

        public DataTreeNode FindNodeByKeyRecursive(string toFind,DataTreeNode node)
        {
            DataTreeNode findNode = null;
            if (node.Key == toFind)
            {
                return node;
            }
            foreach(DataTreeNode n in node.Nodes)
            {
                DataTreeNode result = FindNodeByKeyRecursive(toFind, n);
                if (result != null)
                {
                    findNode = result;
                }
            }
            return findNode;
        }

    
        public DataTreeNode FindNodeByKeyAllChilds(String toFind)
        {
            DataTreeNode findNode = null;
            foreach(DataTreeNode n in MainWebTreetest.Nodes)
            {
                if (n.Key == toFind)
                {
                    findNode = n;
                }
                else
                {
                    DataTreeNode result = FindNodeByKeyRecursive(toFind, n);
                    if (result != null)
                    {
                        findNode = result;
                    }
                }
            }
            return findNode;
            
        
        }

        private void CheckParents(DataTreeNode noeud, bool Check)
        {
            if (noeud.ParentNode != null)
            {
                if (Check)
                { noeud.ParentNode.CheckState = Infragistics.Web.UI.CheckBoxState.Checked; }
                else
                { noeud.ParentNode.CheckState = Infragistics.Web.UI.CheckBoxState.Unchecked; }
                
                CheckParents(noeud.ParentNode,Check);
            }
            else
            {
                return;
            }
        }


        private void MakeParentsTag()
        {
            foreach (DataTreeNode n in MainWebTreetest.Nodes)
            {
               MakeTagOfNode(n);
            }
        }
        private string MakeTagOfNode(DataTreeNode n)
        {
            int NbreChecked = 0, NbreUnChecked = 0, NbrePartial = 0;

            if (n.Nodes.Count != 0)
            {
                foreach (DataTreeNode n2 in n.Nodes)
                {
                    if (TypeCheckAction != ETypeCheck.GroupType) { n.Key += "/" + MakeTagOfNode(n2); }
                    if ((n2.CheckState == Infragistics.Web.UI.CheckBoxState.Checked) && (n2.Visible)) { NbreChecked++; }
                    if ((n2.CheckState == Infragistics.Web.UI.CheckBoxState.Unchecked) && (n2.Visible)) { NbreUnChecked++; }
                    if (n2.CheckState == Infragistics.Web.UI.CheckBoxState.Partial) { NbrePartial++; }
                }
                n.CheckState = Infragistics.Web.UI.CheckBoxState.Unchecked;
                if (NbrePartial > 0)
                {
                    n.CheckState = Infragistics.Web.UI.CheckBoxState.Partial;
                }
                if ((NbrePartial == 0) && (NbreUnChecked == 0))
                {
                    n.CheckState = Infragistics.Web.UI.CheckBoxState.Checked;
                }
                if ((NbreChecked > 0) && (NbreUnChecked > 0))
                {
                    n.CheckState = Infragistics.Web.UI.CheckBoxState.Partial;
                }
            }
            return n.Key.ToString();
        }

        #endregion

        #region actions

        private void ModifCheckOfChilds(DataTreeNode noeud,bool Check)
        {
            foreach (DataTreeNode n in noeud.Nodes)
            {
                if (n.Nodes.Count == 0)
                {
                    try
                    {

                        Mworker.DataAccess.UserAccountVehicule oUserV = new Mworker.DataAccess.UserAccountVehicule(_userName, _userId, n.Key.ToString(), _userBlclient);
                        if (TypeCheckAction == ETypeCheck.ShowMap)
                        { oUserV.ShowOnMap = Check; }
                        if (TypeCheckAction == ETypeCheck.Sms)
                        { oUserV.SendSMS = Check; }

                        oUserV.save();
                    }
                    catch (Exception )
                    { }
                }
                else
                {
                    ModifCheckOfChilds(n,Check);
                }
            }
        }

        protected void TimerRessources_Tick(object sender, EventArgs e)
        {
            DoRefresh();
        }

        protected void txt_search_EnterKeyPress(object sender, EventArgs e)
        {
            DoRefresh();
        }

        private void CheckGroupType()
        {
            Mworker.DataAccess.GroupType oGT = new Mworker.DataAccess.GroupType();
            oGT.Group = _CurrentGroup;
            oGT.AssetType = Typeressource;
            DataTable dt = oGT.getList();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                DataTreeNode node =  FindNodeByKeyAllChilds(dt.Rows[i]["Type"].ToString());
                if ((node != null) && (!node.HasChildren))
                {
                    node.CheckState = Infragistics.Web.UI.CheckBoxState.Checked;
                }
            }

            MakeParentsTag();
        }

        private void DoRefreshGroupType()
        {
            MainWebTreetest.Nodes.Clear();
            CreateNodesType(MainWebTreetest);
            CheckGroupType(); 
        }

        private void DoRefresh()
        {
 
            if (TypeCheckAction == ETypeCheck.GroupType)
            {
                DoRefreshGroupType();
            }
            else
            {
                DoRefreshDetail();
            }
        }

        private void DoRefreshDetail()
        {
            getCookieClient();
            DataTable dt = new DataTable();
            if (TypeRessource == ETypeRessource.MobileAsset)
            {
                if (TypeCheckAction == ETypeCheck.UserAccount)
                {
                    Mworker.DataAccess.UserAccountVehicule oAcc = new Mworker.DataAccess.UserAccountVehicule(_userName, UserID, _userBlclient);
                    dt = oAcc.getTreeView();
                }
                else
                {
                    Mworker.DataAccess.Ressource oRess = new Mworker.DataAccess.Ressource(_userName, _userBlclient, _userId, true);
                    if (TxtSearch.Value != "")
                    { oRess.Description = "%" + TxtSearch.Value + "%"; }
                    if ((ddlType.SelectedValue.ToString() != "0") && (ddlType.SelectedValue.ToString() != ""))
                    {
                        oRess.Type = ddlType.SelectedValue.ToString();
                    }
                    else
                    {
                        oRess.Type = null;
                    }
                    dt = oRess.getTreeviewRessources();
                }
                 RefreshTreeView(dt);
            }
            if (TypeRessource == ETypeRessource.PassiveAsset)
            {
                if (TypeCheckAction == ETypeCheck.UserAccount)
                {
                    Mworker.DataAccess.UserAccountPassiveAsset oAcc = new Mworker.DataAccess.UserAccountPassiveAsset(_userName, _userBlclient, UserID, null);
                    dt = oAcc.getTreeView();
                }
                else
                {
                    Mworker.DataAccess.PassiveAsset oPassiveAsset = new Mworker.DataAccess.PassiveAsset(_userBlclient, _userName, _userId, null);
                    if (TxtSearch.Value != "")
                    { oPassiveAsset.description = "%" + TxtSearch.Value + "%"; }
                    if (ddlType.SelectedValue.ToString() != "0")
                    {
                        try
                        {
                            oPassiveAsset.type = ddlType.SelectedValue.ToString();
                        }
                        catch { }
                    }
                    dt = oPassiveAsset.getTreeview();
                }
                RefreshTreeView(dt);
            }
            if (TypeRessource == ETypeRessource.Zone)
            {
                if (TypeCheckAction == ETypeCheck.UserAccount)
                {
                    Mworker.DataAccess.UserAccountAsset oAA = new Mworker.DataAccess.UserAccountAsset(UserID, "Zone");
                    dt = oAA.getTreeView();
                }
                else
                {
                    Mworker.DataAccess.Zone oZone = new Mworker.DataAccess.Zone(_userId, _userBlclient );
                    if (TxtSearch.Value != "")
                    { oZone.Description = "%" + TxtSearch.Value + "%"; }
                    if (ddlType.SelectedValue.ToString() != "0")
                    {
                        try
                        {
                            oZone.Type = ddlType.SelectedValue.ToString();
                        }
                        catch { }
                    }
                    dt = oZone.getTreeview();
                }
                RefreshTreeView(dt);
            }
 
        }

        private void HideAllParents(DataTreeNode n,bool Hide)
        {
            if (n != null)
            {
                n.Visible = !Hide;
                HideAllParents(n.ParentNode,Hide);
            }
        }

        private void HideAllChilds(DataTreeNode n, bool Hide)
        {
            if (n != null)
            {
                n.Visible = !Hide;
                foreach (DataTreeNode n1 in n.Nodes)
                { HideAllChilds(n1, Hide); }
            }
        }

        private void GetExpandedStateOfChild(DataTreeNode n, Dictionary<String, bool> Liste)
        {
            foreach (DataTreeNode n2 in n.Nodes)
            {
                Liste.Add(n2.Key.ToString(), n2.Expanded);
                GetExpandedStateOfChild(n2, Liste);
            }
        }
        private void ExpandChild(DataTreeNode n, Dictionary<String, bool> Liste)
        {
            foreach (DataTreeNode n2 in n.Nodes)
            {
                if (Liste.ContainsKey(n2.Key.ToString()))
                {
                    if (Liste[n2.Key.ToString()])
                        n2.Expanded = true;
                    else
                        n2.Expanded = false;
                }
                ExpandChild(n2, Liste);
            }
        }

        private void RefreshTreeView(DataTable dt)
        {

            Dictionary<String, bool> ListOfNodeExpandedState = new Dictionary<string, bool>();
            foreach (DataTreeNode n in MainWebTreetest.Nodes)
            {
                try
                {
                    ListOfNodeExpandedState.Add(n.Key.ToString(), n.Expanded);
                }
                catch
                {}
                GetExpandedStateOfChild(n, ListOfNodeExpandedState);
            }
            
            MainWebTreetest = this.loadTreeViewRess(MainWebTreetest, dt);
            foreach (DataTreeNode n in MainWebTreetest.Nodes)
            {
                if (ListOfNodeExpandedState.ContainsKey(n.Key.ToString()))
                {
                    if (ListOfNodeExpandedState[n.Key.ToString()])
                        n.Expanded = true;
                    else
                        n.Expanded = false;
                }
                ExpandChild(n, ListOfNodeExpandedState);
            }
        }
 
        #endregion

        protected void MainWebTreetest_CheckBoxSelectionChanged(object sender, DataTreeCheckBoxSelectionEventArgs e)
        {
            //TODO
            foreach (DataTreeNode node in e.OldCheckedNodes)
            {
                if (!e.NewCheckedNodes.Contains(node))
                {//Uncheck
                    NodeUnChecked(node);
                }
            }
            foreach (DataTreeNode node in e.NewCheckedNodes)
            {//Check
                if (!e.OldCheckedNodes.Contains(node))
                {
                    NodeChecked(node);
                    ParentCheck(node);
                }
            }
        }

        private void ParentCheck(DataTreeNode node)
        {
            if (node.ParentNode != null)
            {
                NodeChecked(node.ParentNode);
                ParentCheck(node.ParentNode);
            }
        }

        private void NodeUnChecked(DataTreeNode node)
        {
            if (!node.HasChildren)
            {
                if (TypeRessource == ETypeRessource.MobileAsset)
                {
                    switch (TypeCheckAction)
                    { 
                        
                        case ETypeCheck.ShowMap:
                            Mworker.DataAccess.UserAccountVehicule oUserV1 = new Mworker.DataAccess.UserAccountVehicule(_userName, _userId, node.Key.ToString(), _userBlclient);
                            oUserV1.ShowOnMap = false; 
                            oUserV1.save();
                            break;
                    }
                }
                
                
            }
          
           
          

        }

        private void NodeChecked(DataTreeNode node)
        {
            if ((!node.HasChildren) && (node.Visible))
            {
                if (TypeRessource == ETypeRessource.MobileAsset)
                {
                            Mworker.DataAccess.UserAccountVehicule oUserV1 = new Mworker.DataAccess.UserAccountVehicule(_userName, _userId, node.Key.ToString(), _userBlclient);
                            oUserV1.ShowOnMap = true; 
                            oUserV1.save();
                }

          
               
            }
           
        }



        protected void ddlType_SelectionChanged(object sender, Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs e)
        {
            DoRefresh();
        }
      

        
    }
    public class ElementTypetest
    {
        public String id;
        public String IDParent;
        public String Description;
        public ElementTypetest(String _id, String _IDParent, String _Description)
        {
            id = _id;
            IDParent = _IDParent;
            Description = _Description;
        }

    }
}